﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace WpfApplication1
{
    public class MainWindowVM : INotifyPropertyChanged
    {
        public MainWindowVM()
        {
            _chartData = new ObservableCollection<ChartData>();
            DateTime dt = new DateTime(2001, 1,1);
            Random rand = new Random();

            for (int i = 0; i < 10; i++)
            {
                _chartData.Add(new ChartData
                {
                    Date = dt.AddDays(i),
                    Value1 = rand.NextDouble() * 10,
                    Value2 = rand.NextDouble() * 20
                });
            }
        }

        private ObservableCollection<ChartData> _chartData = null;

        public ObservableCollection<ChartData> ChartSource
        {
            get
            {
                return _chartData;
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }

    public class ChartData : INotifyPropertyChanged
    {
        private DateTime _date;
        private double _value1, _value2;

        public DateTime Date
        {
            get { return _date; }
            set
            {
                if (_date == value)
                    return;
                _date = value;
                OnPropertyChanged("Date");
            }
        }
        public double Value1
        {
            get { return _value1; }
            set
            {
                if (_value1 == value)
                    return;
                _value1 = value;
                OnPropertyChanged("Value1");
            }
        }
        public double Value2
        {
            get { return _value2; }
            set
            {
                if (_value2 == value)
                    return;
                _value2 = value;
                OnPropertyChanged("Value2");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
